## START: Set by rpmautospec
## (rpmautospec version 0.2.5)
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

%global with_devel 1

%if 0%{?fedora}
%global with_debug 1
%else
%global with_debug 0
%endif

%if 0%{?with_debug}
%global _find_debuginfo_dwz_opts %{nil}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%if ! 0%{?gobuild:1}
%define gobuild(o:) GO111MODULE=off go build -buildmode pie -compiler gc -tags="rpm_crashtraceback ${BUILDTAGS:-}" -ldflags "${LDFLAGS:-} -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \\n') -extldflags '-Wl,-z,relro -Wl,-z,now -specs=/usr/lib/rpm/redhat/redhat-hardened-ld '" -a -v -x %{?**};
%endif

%global provider github
%global provider_tld com
%global project containernetworking
%global repo plugins
%global import_path %{provider}.%{provider_tld}/%{project}/%{repo}
%global git0 https://%{import_path}

%global built_tag v1.1.0
%global built_tag_strip %(b=%{built_tag}; echo ${b:1})
%global gen_version %(b=%{built_tag_strip}; echo ${b/-/"~"})

Name: %{project}-%{repo}
Version: %{gen_version}
Release: %autorelease
Summary: Libraries for writing CNI plugin
License: ASL 2.0
URL: %{git0}
Source0: %{git0}/archive/%{built_tag}.tar.gz
BuildRequires: golang >= 1.16.6
BuildRequires: go-rpm-macros
BuildRequires: git
BuildRequires: go-md2man
BuildRequires: go-rpm-macros
BuildRequires: systemd-devel
Requires: systemd

Obsoletes: %{project}-cni < 0.7.1-2
Provides: %{project}-cni = %{version}-%{release}
Provides: kubernetes-cni
Provides: container-network-stack = 1

%description
The CNI (Container Network Interface) project consists of a specification
and libraries for writing plugins to configure network interfaces in Linux
containers, along with a number of supported plugins. CNI concerns itself
only with network connectivity of containers and removing allocated resources
when the container is deleted.

%prep
%autosetup -Sgit -n %{repo}-%{built_tag_strip}
rm -rf plugins/main/windows

# Use correct paths in cni-dhcp unitfiles
sed -i 's/\/opt\/cni\/bin/\%{_prefix}\/libexec\/cni/' plugins/ipam/dhcp/systemd/cni-dhcp.service

%build
export ORG_PATH="%{provider}.%{provider_tld}/%{project}"
export REPO_PATH="$ORG_PATH/%{repo}"

if [ ! -h gopath/src/${REPO_PATH} ]; then
        mkdir -p gopath/src/${ORG_PATH}
        ln -s ../../../.. gopath/src/${REPO_PATH} || exit 255
fi

export GOPATH=$(pwd)/gopath
mkdir -p $(pwd)/bin

echo "Building plugins"
export PLUGINS="plugins/meta/* plugins/main/* plugins/ipam/* plugins/sample"
for d in $PLUGINS; do
        if [ -d "$d" ]; then
                plugin="$(basename "$d")"
                echo "  $plugin"
                %gobuild -o "${PWD}/bin/$plugin" "$@" "$REPO_PATH"/$d
        fi
done

%install
install -d -p %{buildroot}%{_libexecdir}/cni/
install -p -m 0755 bin/* %{buildroot}/%{_libexecdir}/cni

install -dp %{buildroot}%{_unitdir}
install -p plugins/ipam/dhcp/systemd/cni-dhcp.service %{buildroot}%{_unitdir}
install -p plugins/ipam/dhcp/systemd/cni-dhcp.socket %{buildroot}%{_unitdir}

#define license tag if not already defined
%{!?_licensedir:%global license %doc}

%files
%license LICENSE
%doc *.md
%dir %{_libexecdir}/cni
%{_libexecdir}/cni/*
%{_unitdir}/cni-dhcp.service
%{_unitdir}/cni-dhcp.socket

%changelog
* Mon Mar 07 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> 1.1.0-1
- bump to v1.1.0

* Wed Feb 02 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> 1.0.1-4
- Provides: container-network-stack = 1

* Mon Jan 24 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> 1.0.1-3
- switch to autospec and Provides: container-network-stack

* Wed Jan 19 2022 Fedora Release Engineering <releng@fedoraproject.org> 1.0.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Wed Sep 08 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> 1.0.1-1
- containernetworking-plugins-1.0.1-1

* Thu Aug 19 2021 Lokesh Mandvekar <lsm5@fedoraproject.org> 1.0.0-14
- containernetworking-plugins-1.0.0-21

* Mon Aug 16 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> 1.0.0-13
- containernetworking-plugins-1.0.0-1

* Mon Aug 02 2021 Lokesh Mandvekar <lsm5@fedoraproject.org> 1.0.0-12
- containernetworking-plugins-1.0.0-20.1.git2876cd5

* Wed Jul 21 2021 Fedora Release Engineering <releng@fedoraproject.org> 1.0.0-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Wed Jul 21 2021 Fedora Release Engineering <releng@fedoraproject.org> 1.0.0-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Thu Jun 17 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> 1.0.0-9
- containernetworking-plugins-1.0.0-18.1.git2876cd5

* Mon Jun 14 2021 Lokesh Mandvekar <lsm5@fedoraproject.org> 1.0.0-8
- containernetworking-plugins-1.0.0-17.1.git5238c13

* Sat Jun 12 2021 Kevin Fenzi <kevin@scrye.com> 1.0.0-7
- Disable debug packages to get rawhide composing.

* Mon Jun 07 2021 Lokesh Mandvekar <lsm5@fedoraproject.org> 1.0.0-6
- containernetworking-plugins-1.0.0-15.1.git5238c13

* Mon Jun 07 2021 Lokesh Mandvekar <lsm5@fedoraproject.org> 1.0.0-5
- Resolves: #1962008

* Thu Jun 03 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> 1.0.0-4
- containernetworking-plugins-1.0.0-14.1.git5238c13

* Thu May 27 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> 1.0.0-3
- containernetworking-plugins-1.0.0-13.1.git78702e9

* Thu May 20 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> 1.0.0-2
- containernetworking-plugins-1.0.0-12.1.git6618a0a

* Thu May 06 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> 1.0.0-1
- containernetworking-plugins-1.0.0-11.1.git8de0287

* Tue Apr 20 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.9.1-10
- containernetworking-plugins-0.9.1-10.1.gitb41052c

* Wed Mar 10 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.9.1-9
- containernetworking-plugins-0.9.1-9.1.git2989aba

* Mon Mar 08 2021 Lokesh Mandvekar <lsm5@fedoraproject.org> 0.9.1-8
- containernetworking-plugins-0.9.1-8.1.gitd385120

* Wed Mar 03 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.9.1-7
- containernetworking-plugins-0.9.1-7.1.gitd385120

* Wed Mar 03 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.9.1-6
- containernetworking-plugins-0.9.1-6.1.git1c1799e

* Wed Mar 03 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.9.1-5
- containernetworking-plugins-0.9.1-5.1.git0ea07b8

* Wed Feb 24 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.9.1-4
- containernetworking-plugins-0.9.1-4.1.git47927f5

* Wed Feb 24 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.9.1-3
- containernetworking-plugins-0.9.1-3.1.git8936113

* Mon Feb 15 2021 Lokesh Mandvekar <lsm5@fedoraproject.org> 0.9.1-2
- containernetworking-plugins-0.9.1-2.1.gitfa48f75

* Fri Feb 05 2021 Lokesh Mandvekar <lsm5@fedoraproject.org> 0.9.1-1
- containernetworking-plugins-0.9.1-1.1.gitfa48f75

* Fri Feb 05 2021 Lokesh Mandvekar <lsm5@fedoraproject.org> 0.9.0-7
- include CVE ID in changelog

* Fri Feb 05 2021 Lokesh Mandvekar <lsm5@fedoraproject.org> 0.9.0-6
- containernetworking-plugins-0.9.0-27.1.git74a6b28

* Wed Jan 27 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.9.0-5
- containernetworking-plugins-0.9.0-26.1.git8feef71

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> 0.9.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Wed Jan 20 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.9.0-3
- containernetworking-plugins-0.9.0-24.1.git8c66d68

* Mon Jan 11 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.9.0-2
- containernetworking-plugins-0.9.0-23.1.git48a97a7

* Thu Jan 07 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.9.0-1
- containernetworking-plugins-0.9.0-22.1.git3819ef7

* Wed Dec 09 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.7-9
- containernetworking-plugins-0.8.7-21.1.gite13bab9

* Wed Nov 25 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.7-8
- containernetworking-plugins-0.8.7-20.1.git509d645

* Thu Nov 19 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.7-7
- containernetworking-plugins-0.8.7-19.1.gitcccf539

* Thu Nov 12 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.7-6
- containernetworking-plugins-0.8.7-18.1.git8aad973

* Thu Nov 05 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.7-5
- containernetworking-plugins-0.8.7-17.1.gitccd872b

* Fri Oct 23 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.7-4
- containernetworking-plugins-0.8.7-16.1.git440dcc3

* Thu Oct 15 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.7-3
- containernetworking-plugins-0.8.7-15.1.gita9abbaf

* Thu Oct 08 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.7-2
- containernetworking-plugins-0.8.7-14.1.git6df03d7

* Wed Sep 16 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.7-1
- containernetworking-plugins-0.8.7-13.1.gite78e6aa

* Wed Aug 26 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.6-12
- containernetworking-plugins-0.8.6-12.1.git9b8de6a

* Wed Aug 05 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.6-11
- containernetworking-plugins-0.8.6-11.1.gitbd58999

* Wed Aug 05 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.6-10
- containernetworking-plugins-0.8.6-10.1.git8a88f90

* Mon Jul 27 2020 Fedora Release Engineering <releng@fedoraproject.org> 0.8.6-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Wed Jul 22 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.6-8
- containernetworking-plugins-0.8.6-8.1.gitd713ec6

* Wed Jul 15 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.6-7
- containernetworking-plugins-0.8.6-7.1.git6eb8e31

* Wed Jul 08 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.6-6
- containernetworking-plugins-0.8.6-6.1.gitc90b165

* Wed Jul 01 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.6-5
- containernetworking-plugins-0.8.6-5.1.git28773dc

* Wed Jun 24 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.6-4
- containernetworking-plugins-0.8.6-4.1.gite1f8f9b

* Wed Jun 03 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.6-3
- containernetworking-plugins-0.8.6-3.1.git1fb9793

* Wed May 27 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.6-2
- containernetworking-plugins-0.8.6-2.1.gitb76fdd7

* Fri May 15 2020 Lokesh Mandvekar <lsm5@fedoraproject.org> 0.8.6-1
- containernetworking-plugins-0.8.6-1.1.gitad10b6f

* Wed May 13 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.5-12
- containernetworking-plugins-0.8.5-8.1.gitad10b6f

* Wed Apr 29 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.5-11
- containernetworking-plugins-0.8.5-7.1.gitf7a2fc9

* Wed Apr 22 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.5-10
- containernetworking-plugins-0.8.5-6.1.git5af9ff4

* Wed Apr 15 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.5-9
- containernetworking-plugins-0.8.5-5.1.gita78853f

* Wed Apr 08 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.5-8
- containernetworking-plugins-0.8.5-4.1.gitf4332fe

* Wed Apr 01 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.5-7
- containernetworking-plugins-0.8.5-3.1.git117e30f

* Fri Mar 20 2020 RH Container Bot <rhcontainerbot@fedoraproject.org> 0.8.5-6
- containernetworking-plugins-0.8.5-2.1.git47a9fd8

* Mon Feb 03 2020 Lokesh Mandvekar <lsm5@fedoraproject.org> 0.8.5-5
- disable debuginfo for centos

* Mon Feb 03 2020 Lokesh Mandvekar <lsm5@fedoraproject.org> 0.8.5-4
- GO111MODULE=off

* Mon Feb 03 2020 Lokesh Mandvekar <lsm5@fedoraproject.org> 0.8.5-3
- use BR: golang

* Mon Feb 03 2020 Lokesh Mandvekar <lsm5@fedoraproject.org> 0.8.5-2
- use go-md2man as builddep

* Thu Jan 30 2020 Lokesh Mandvekar <lsm5@fedoraproject.org> 0.8.5-1
- containernetworking-plugins-0.8.5-1.1.gitf5c3d1b

* Tue Jan 28 2020 Fedora Release Engineering <releng@fedoraproject.org> 0.8.2-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Wed Sep 18 2019 Lokesh Mandvekar (Bot) <lsm5+bot@fedoraproject.org> 0.8.2-4
- containernetworking-plugins-0.8.2-0.4.dev.git291ab6c

* Wed Sep 11 2019 Lokesh Mandvekar (Bot) <lsm5+bot@fedoraproject.org> 0.8.2-3
- containernetworking-plugins-0.8.2-0.3.dev.git23d5525

* Wed Sep 11 2019 Lokesh Mandvekar (Bot) <lsm5+bot@fedoraproject.org> 0.8.2-2
- containernetworking-plugins-0.8.2-0.2.dev.git4bb2881

* Wed Aug 28 2019 Lokesh Mandvekar (Bot) <lsm5+bot@fedoraproject.org> 0.8.2-1
- containernetworking-plugins-0.8.2-0.1.dev.git7e68430

* Wed Aug 14 2019 Lokesh Mandvekar (Bot) <lsm5+bot@fedoraproject.org> 0.8.1-9
- containernetworking-plugins-0.8.1-7.1.dev.git485be65

* Wed Aug 14 2019 Lokesh Mandvekar (Bot) <lsm5+bot@fedoraproject.org> 0.8.1-8
- containernetworking-plugins-0.8.1-6.1.dev.gitc9e1c0c

* Mon Aug 12 2019 Lokesh Mandvekar (Bot) <lsm5+bot@fedoraproject.org> 0.8.1-7
- containernetworking-plugins-0.8.1-5.1.dev.git2d6d4b2

* Wed Aug 07 2019 Lokesh Mandvekar (Bot) <lsm5+bot@fedoraproject.org> 0.8.1-6
- containernetworking-plugins-0.8.1-4.1.dev.gitccd683e

* Wed Jul 31 2019 Lokesh Mandvekar <lsm5@fedoraproject.org> 0.8.1-5
- built_tag macro records exact upstream tag built

* Wed Jul 24 2019 Lokesh Mandvekar (Bot) <lsm5+bot@fedoraproject.org> 0.8.1-4
- containernetworking-plugins-0.8.1-3.1.dev.gitded2f17

* Thu Jul 18 2019 Lokesh Mandvekar (Bot) <lsm5+bot@fedoraproject.org> 0.8.1-3
- containernetworking-plugins-0.8.1-2.1.dev.git7ba2bcf

* Wed Jul 10 2019 Lokesh Mandvekar <lsm5@fedoraproject.org> 0.8.1-2
- containernetworking-plugins-0.8.1-1.1.dev.git966bbcb

* Fri Jun 07 2019 Lokesh Mandvekar <lsm5@fedoraproject.org> 0.8.1-1
- containernetworking-plugins-0.8.1-1

* Fri May 31 2019 Lokesh Mandvekar <lsm5@redhat.com> 0.7.5-3
- add centos7 conditionals

* Fri May 31 2019 Lokesh Mandvekar <lsm5@fedoraproject.org> 0.7.5-2
- BR: git and remove ExcludeArch

* Fri May 31 2019 Lokesh Mandvekar <lsm5@fedoraproject.org> 0.7.5-1
- containernetworking-plugins-0.7.5-1

* Wed Feb 27 2019 Jason Brooks <jbrooks@redhat.com> 0.7.4-2
- add provides kubernetes-cni for upstream kubelet compat

* Wed Feb 13 2019 Lokesh Mandvekar <lsm5@fedoraproject.org> 0.7.4-1
- containernetworking-plugins-0.7.4-1

* Thu Jan 31 2019 Fedora Release Engineering <releng@fedoraproject.org> 0.7.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Thu Aug 30 2018 Lokesh Mandvekar <lsm5@fedoraproject.org> 0.7.3-2
- containernetworking-plugins-0.7.3-2

* Mon Aug 20 2018 Lokesh Mandvekar <lsm5@fedoraproject.org> 0.7.3-1
- containernetworking-plugins-0.7.3-1
